package com.sun.nio.sctp;

import java.nio.ByteBuffer;
import java.util.Set;
import java.net.InetAddress;
import java.net.SocketAddress;
import java.io.IOException;
import sun.nio.ch.sctp.SctpChannelImpl;
import java.nio.channels.spi.SelectorProvider;
import jdk.Exported;
import java.nio.channels.spi.AbstractSelectableChannel;

@Exported
public abstract class SctpChannel extends AbstractSelectableChannel
{
    protected SctpChannel(SelectorProvider provider) {
        super(provider);
    }
    
    public static SctpChannel open() throws IOException {
        return new SctpChannelImpl((SelectorProvider)null);
    }
    
    public static SctpChannel open(SocketAddress socketAddress, int n, int n2) throws IOException {
        SctpChannel open = open();
        open.connect(socketAddress, n, n2);
        return open;
    }
    
    public abstract Association association() throws IOException;
    
    public abstract SctpChannel bind(SocketAddress p0) throws IOException;
    
    public abstract SctpChannel bindAddress(InetAddress p0) throws IOException;
    
    public abstract SctpChannel unbindAddress(InetAddress p0) throws IOException;
    
    public abstract boolean connect(SocketAddress p0) throws IOException;
    
    public abstract boolean connect(SocketAddress p0, int p1, int p2) throws IOException;
    
    public abstract boolean isConnectionPending();
    
    public abstract boolean finishConnect() throws IOException;
    
    public abstract Set<SocketAddress> getAllLocalAddresses() throws IOException;
    
    public abstract Set<SocketAddress> getRemoteAddresses() throws IOException;
    
    public abstract SctpChannel shutdown() throws IOException;
    
    public abstract <T> T getOption(SctpSocketOption<T> p0) throws IOException;
    
    public abstract <T> SctpChannel setOption(SctpSocketOption<T> p0, T p1) throws IOException;
    
    public abstract Set<SctpSocketOption<?>> supportedOptions();
    
    @Override
    public final int validOps() {
        return 13;
    }
    
    public abstract <T> MessageInfo receive(ByteBuffer p0, T p1, NotificationHandler<T> p2) throws IOException;
    
    public abstract int send(ByteBuffer p0, MessageInfo p1) throws IOException;
}
